GDB (xrefs)

Public Member Functions | Private Attributes | List of all members
dtrace_probe Class Reference
Inheritance diagram for dtrace_probe:

## Public Member Functions
| dtrace_probe (std::string &&name_, std::string &&provider_, CORE_ADDR address_, struct gdbarch *arch_, std::vector< struct dtrace_probe_arg > &&args_, std::vector< struct dtrace_probe_enabler > &&enablers_)
CORE_ADDR | get_relocated_address (struct objfile *objfile) override
unsigned | get_argument_count (struct frame_info *frame) override
bool | can_evaluate_arguments () const override
struct value * | evaluate_argument (unsigned n, struct frame_info *frame) override
void | compile_to_ax (struct agent_expr *aexpr, struct axs_value *axs_value, unsigned n) override
const static_probe_ops * | get_static_ops () const override
std::vector< const char * > | gen_info_probes_table_values () const override
void | enable () override
void | disable () override
struct dtrace_probe_arg * | get_arg_by_number (unsigned n, struct gdbarch *gdbarch)
void | build_arg_exprs (struct gdbarch *gdbarch)
bool | is_enabled () const
Public Member Functions inherited from probe
| probe (std::string &&name_, std::string &&provider_, CORE_ADDR address_, struct gdbarch *arch_)
virtual | ~probe ()
virtual void | set_semaphore (struct objfile *objfile, struct gdbarch *gdbarch)
virtual void | clear_semaphore (struct objfile *objfile, struct gdbarch *gdbarch)
const std::string & | get_name () const
const std::string & | get_provider () const
CORE_ADDR | get_address () const
struct gdbarch * | get_gdbarch () const

## Private Attributes
std::vector< struct dtrace_probe_arg > | m_args
std::vector< struct dtrace_probe_enabler > | m_enablers
bool | m_args_expr_built

## Detailed Description

Definition at line 107 of file dtrace-probe.c.

## Constructor & Destructor Documentation

## ◆ dtrace_probe()

dtrace_probe::dtrace_probe | ( | std::string && | name_,
|  | std::string && | provider_,
|  | CORE_ADDR | address_,
|  | struct gdbarch * | arch_,
|  | std::vector< struct dtrace_probe_arg > && | args_,
|  | std::vector< struct dtrace_probe_enabler > && | enablers_
| ) |  |
| inline

Definition at line 111 of file dtrace-probe.c.

## Member Function Documentation

## ◆ build_arg_exprs()

void dtrace_probe::build_arg_exprs | ( | struct gdbarch * | gdbarch | ) |

Definition at line 618 of file dtrace-probe.c.

References current_language, gdbarch_dtrace_parse_probe_argument(), m_args, m_args_expr_built, prefixify_expression(), pstate, parser_state::release(), write_exp_elt_opcode(), and write_exp_elt_type().

Referenced by get_arg_by_number().

## ◆ can_evaluate_arguments()

bool dtrace_probe::can_evaluate_arguments | ( |  | ) | const
| override virtual

Implements probe.

Definition at line 706 of file dtrace-probe.c.

References gdbarch_dtrace_parse_probe_argument_p(), and probe::get_gdbarch().

## ◆ compile_to_ax()

void dtrace_probe::compile_to_ax | ( | struct agent_expr * | aexpr,
|  | struct axs_value * | axs_value,
|  | unsigned | n
| ) |  |
| override virtual

Implements probe.

Definition at line 731 of file dtrace-probe.c.

References dtrace_probe_arg::expr, agent_expr::gdbarch, gen_expr(), get_arg_by_number(), require_rvalue(), dtrace_probe_arg::type, and value::type.

## ◆ disable()

void dtrace_probe::disable | ( |  | ) |
| override virtual

Reimplemented from probe.

Definition at line 800 of file dtrace-probe.c.

References _, error(), gdbarch_dtrace_disable_probe(), gdbarch_dtrace_disable_probe_p(), probe::get_gdbarch(), probe::get_name(), probe::get_provider(), inferior_ptid, is_enabled(), m_enablers, null_ptid, and ptid_equal().

## ◆ enable()

void dtrace_probe::enable | ( |  | ) |
| override virtual

Reimplemented from probe.

Definition at line 776 of file dtrace-probe.c.

References _, error(), gdbarch_dtrace_enable_probe(), gdbarch_dtrace_enable_probe_p(), probe::get_gdbarch(), inferior_ptid, is_enabled(), m_enablers, null_ptid, and ptid_equal().

## ◆ evaluate_argument()

struct value * dtrace_probe::evaluate_argument | ( | unsigned | n,
|  | struct frame_info * | frame
| ) |  |
| override virtual

Implements probe.

Definition at line 716 of file dtrace-probe.c.

References EVAL_NORMAL, evaluate_subexp_standard(), dtrace_probe_arg::expr, get_arg_by_number(), probe::get_gdbarch(), and dtrace_probe_arg::type.

## ◆ gen_info_probes_table_values()

std::vector< const char * > dtrace_probe::gen_info_probes_table_values | ( |  | ) | const
| override virtual

Reimplemented from probe.

Definition at line 757 of file dtrace-probe.c.

References gdbarch_dtrace_probe_is_enabled_p(), probe::get_gdbarch(), is_enabled(), and m_enablers.

## ◆ get_arg_by_number()

struct dtrace_probe_arg * dtrace_probe::get_arg_by_number | ( | unsigned | n,
|  | struct gdbarch * | gdbarch
| ) |  |

Definition at line 656 of file dtrace-probe.c.

References _, build_arg_exprs(), probe::get_name(), internal_error(), m_args, and m_args_expr_built.

Referenced by compile_to_ax(), and evaluate_argument().

## ◆ get_argument_count()

unsigned dtrace_probe::get_argument_count | ( | struct frame_info * | frame | ) |
| override virtual

Implements probe.

Definition at line 698 of file dtrace-probe.c.

References m_args.

## ◆ get_relocated_address()

CORE_ADDR dtrace_probe::get_relocated_address | ( | struct objfile * | objfile | ) |
| override virtual

Implements probe.

Definition at line 689 of file dtrace-probe.c.

References ANOFFSET, probe::get_address(), SECT_OFF_DATA, and objfile::section_offsets.

## ◆ get_static_ops()

const static_probe_ops * dtrace_probe::get_static_ops | ( |  | ) | const
| override virtual

Implements probe.

Definition at line 749 of file dtrace-probe.c.

References dtrace_static_probe_ops.

## ◆ is_enabled()

bool dtrace_probe::is_enabled | ( |  | ) | const

Definition at line 675 of file dtrace-probe.c.

References gdbarch_dtrace_probe_is_enabled(), probe::get_gdbarch(), and m_enablers.

Referenced by disable(), enable(), and gen_info_probes_table_values().

## Member Data Documentation

## ◆ m_args

std::vector<struct dtrace_probe_arg> dtrace_probe::m_args
| private

Definition at line 166 of file dtrace-probe.c.

Referenced by build_arg_exprs(), get_arg_by_number(), and get_argument_count().

## ◆ m_args_expr_built

bool dtrace_probe::m_args_expr_built
| private

Definition at line 172 of file dtrace-probe.c.

Referenced by build_arg_exprs(), and get_arg_by_number().

## ◆ m_enablers

std::vector<struct dtrace_probe_enabler> dtrace_probe::m_enablers
| private

Definition at line 169 of file dtrace-probe.c.

Referenced by disable(), enable(), gen_info_probes_table_values(), and is_enabled().

The documentation for this class was generated from the following file:

- /tmp/gdb-8.1/gdb/dtrace-probe.c